# 
# $Copyright
# Copyright 1993, 1994, 1995  Intel Corporation
# INTEL CONFIDENTIAL
# The technical data and computer software contained herein are subject
# to the copyright notices; trademarks; and use and disclosure
# restrictions identified in the file located in /etc/copyright on
# this system.
# Copyright$
# 
 
.\"
.\" Mach Operating System
.\" Copyright (c) 1991,1990 Carnegie Mellon University
.\" All Rights Reserved.
.\" 
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\" 
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS 
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\" 
.\" Carnegie Mellon requests users of this software to return to
.\" 
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\" 
.\" any improvements or extensions that they make and grant Carnegie the
.\" rights to redistribute these changes.
.\"
.\" HISTORY
.\" $Log: ms.man,v $
# Revision 1.2  1994/11/19  03:02:00  mtm
# Copyright additions/changes
#
# Revision 1.1  1993/07/19  16:14:24  stans
# CMU ms man page
#
.\" Revision 2.5  91/08/29  15:49:07  rpd
.\" 	Added -dp.
.\" 	[91/08/15            rpd]
.\" 
.\" Revision 2.4  91/03/19  12:32:06  mrt
.\" 	Changed to new copyright
.\" 
.\" Revision 2.3  91/03/10  13:41:33  rpd
.\" 	Added -v.
.\" 	[91/01/14            rpd]
.\" 
.\" Revision 2.2  90/09/12  16:32:53  rpd
.\" 	Created.
.\" 	[90/06/18            rpd]
.\" 
.TH MS 1 6/18/90
.CM 4
.SH NAME
ms \- display Mach status
.SH SYNOPSIS
\fBms\fP [\fB-host\fP machine] [\fB-v\fP] [\fB-t\fP|\fB-th\fP|\fB-h\fP|\fB-ps\fP|\fB-p\fP|\fB-tt\fP|\fB-ipc\fP] ids...
.SH DESCRIPTION
\fIms(1)\fR displays general status information.
.PP
\fIms\fR can display the status of threads, tasks, hosts, processors,
and processor sets.  If no MachIDs are specified, then \fIms\fR
displays all objects of the correct type.  Otherwise, \fIms\fR
displays the specified objects, coercing the types if necessary.
.PP
For example, when displaying task status, a thread is converted
to the task containing the thread.  A processor set is converted
to the tasks contained in the processor set.  A host is converted
to the tasks running on the host.  When displaying host status,
a task is converted to the host it is running on.  Etc.
.PP
\fIms\fP interprets the following options:
.TP 8
.B \-host \fImachine\fR
Directs the inquiry to the \fImachid(1)\fR server running
on the specified machine.
.TP 8
.B \-v
Causes more information to be displayed in some modes.
.TP 8
.B \-tt
Display the most useful task information, including some information
about each thread in the task.  The default.
.TP 8
.B \-t
Display task status.
.TP 8
.B \-th
Display thread status.
.TP 8
.B \-h
Display host status, including the host's default processor set
and default pager.
.TP 8
.B \-ps
Display processor set status.
.TP 8
.B \-dp
Display default pager status.
.TP 8
.B \-p
Display processor status.
.TP 8
.B \-ipc
Display IPC task status.  If \fB-v\fR is also specified, then
\fImachid\fR displays a summary of IPC data structure usage on a host.
In this mode, \fImachid\fR takes at most one privileged host MachID
argument on the command line.
.SH "SEE ALSO"
mkill(1), mnice(1), pinfo(1), vminfo(1), machid(1),
thread_info(2), task_info(2), host_info(2),
processor_info(2), processor_set_info(2)
